// rng.cpp
//
// Created by Daniel Schwartz-Narbonne on 25/04/07.
//
// Copyright 2007 Princeton University
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.


#include <stdlib.h>
#include <time.h>
#include "rng.h"
#include "AtomicPtr.h"

//global seed used for rng initialization
unsigned int Rng::seed = 0;
threads::AtomicPtr<unsigned int> Rng::p = threads::AtomicPtr<unsigned int>(&(Rng::seed));

#ifdef ENABLE_THREADS  
//pthread_mutex_t Rng::seed_lock = PTHREAD_MUTEX_INITIALIZER;
#endif

//actually declare the static member of the class.  C++ can be ugly sometimes

long Rng::rand(int max)
{
	return _rng->randInt(max-1);//need to round off to keep BELOW max!
}


long Rng::rand()
{
	return _rng->randInt();
}

double Rng::drand()
{
	return _rng->rand();
}

